OUTPUT_ARCH(blarg)
ENTRY(start)
SECTIONS
{
	. = 0x0;
	_text = .;
	.text : {
		_start = .;
		*(.start)
		. = ALIGN(2);
		*(.text)
		. = ALIGN(2);
		*(.fixup)
		. = ALIGN(2);
		*(.gnu.warning)
		. = ALIGN(2);
		*(.rodata)
		. = ALIGN(2);
		*(.rodata.*)
		. = ALIGN(2);
	}
	_etext = .;

	. = 0x8000*2;	/* bytes, not words */
	_bss = .;
	.bss : { *(.bss) }
	_end = .;
}
